//+------------------------------------------------------------------+
//|                                         Ilan Dinamic 1.61 HT.mq5 |
//|                                 Copyright 2014, Vasiliy Sokolov. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, developing Vasiliy Sokolov."
#property link      "http://www.mql5.com"
#property version   "1.60"

#include <Prototypes.mqh>
#include <Trade\Trade.mqh>
#include <TradeState.mqh>
#include <Environment.mqh>
#include <Indicators.mqh>
#include <TesterTable.mqh>
#include <DrawHedgePosition.mqh>

/*
                       
        (    
                  Ilan Dinamic  MetaTrader 4)
*/
//+------------------------------------------------------------------+
//|    .                             |
//+------------------------------------------------------------------+
input string PRIMARY_MM_PARAMETERS = "";
//+------------------------------------------------------------------+
//|        .       |
//| ,  LotExponent = 1.4:   0.1, :      |
//| 0.16, 0.26, 0.43;                                                |
//+------------------------------------------------------------------+
input double LotExponent = 1.4;
//+------------------------------------------------------------------+
//|     .           |
//+------------------------------------------------------------------+
input int MaxTrades = 10;
//+------------------------------------------------------------------+
//| ,     .         |
//+------------------------------------------------------------------+
input bool DynamicPips = true; 
//+------------------------------------------------------------------+
//|        ( 15).         | 
//+------------------------------------------------------------------+
input int DefaultPips = 120; 
//+------------------------------------------------------------------+
//|   ,          |
//|   High-Low.                                       |
//+------------------------------------------------------------------+
input int Glubina = 24; 
//+------------------------------------------------------------------+
//| ,     .
//+------------------------------------------------------------------+
input int DEL = 3;
//+------------------------------------------------------------------+
//|     .                                   |
//+------------------------------------------------------------------+
input double Lots = 0.1;
//+------------------------------------------------------------------+
//| C      .                |
//| 0 -   (1.0), 1 -  (0.1), 2 -  (0.01)  |
//+------------------------------------------------------------------+
input int lotdecimal = 1;
//+------------------------------------------------------------------+
//|       .         |
//+------------------------------------------------------------------+
input double TakeProfit = 100.0;
//+------------------------------------------------------------------+
//|     ,                   |
//|   (     ).     |
//+------------------------------------------------------------------+
input ulong slippage = 30;
//+------------------------------------------------------------------+
//|    (magic-).                 |
//+------------------------------------------------------------------+
input int MagicNumber = 2222;
//+------------------------------------------------------------------+
//|  ,     .                   |
//+------------------------------------------------------------------+
input string ENTRY_POSITION_PARAMETERS;
//+------------------------------------------------------------------+
//|  RSI.                                                      |
//+------------------------------------------------------------------+
input int RsiPeriod = 14;
//+------------------------------------------------------------------+
//|   RSI.                                              |
//+------------------------------------------------------------------+
input double RsiMinimum = 30.0;
//+------------------------------------------------------------------+
//|   RSI.                                             |
//+------------------------------------------------------------------+
input double RsiMaximum = 70.0;

//+------------------------------------------------------------------+
//|    -.                |
//+------------------------------------------------------------------+
input string USING_CLASSIC_STOP = "";
//+------------------------------------------------------------------+
//| ,             |
//| -.                                                       | 
//+------------------------------------------------------------------+
input bool UseStopLoss = false;
//+------------------------------------------------------------------+
//|   -.                                 |
//+------------------------------------------------------------------+
input double StopLoss = 500.0;

//+------------------------------------------------------------------+
//|   -  .                      |
//+------------------------------------------------------------------+
input string USING_EQUITY_STOP = "";
//+------------------------------------------------------------------+
//| ,      equity.              |
//+------------------------------------------------------------------+
input bool UseEquityStop = false;
//+------------------------------------------------------------------+
//|     ,   equity . |
//|        quity.         |
//+------------------------------------------------------------------+
input double EquityPercent = 1.0;
//+------------------------------------------------------------------+
//| %     .                     |
//+------------------------------------------------------------------+
input double TotalEquityRisk = 20.0;
//+------------------------------------------------------------------+
//|    .                            |
//+------------------------------------------------------------------+
input string USING_TRAILING_STOP = "";
//+------------------------------------------------------------------+
//| ,     .               |
//+------------------------------------------------------------------+
input bool UseTrailingStop = false;
//+------------------------------------------------------------------+
//|       ,         |
//|     .                       |
//+------------------------------------------------------------------+
input double TrailStart = 100.0;
//+------------------------------------------------------------------+
//|        StopLoss,     |
//| .                                                    |
//+------------------------------------------------------------------+
input double TrailStop = 100.0;
//+------------------------------------------------------------------+
//|      CCI.                   |
//+------------------------------------------------------------------+
input string USING_CCI_STOP = "";
//+------------------------------------------------------------------+
//| ,               |
//|  CCI  CCILevel.                                  |
//+------------------------------------------------------------------+
input bool UseCCIStop;
//+------------------------------------------------------------------+
//|   GCCI                                            |
//+------------------------------------------------------------------+
input int CCIPeriod = 55;
//+------------------------------------------------------------------+
//|    CCI,   ,      |
//|      (            |
//|   4   'Drop').                     |
//+------------------------------------------------------------------+
input double CCILevel = 500;                                             

//+------------------------------------------------------------------+
//|     .                      |
//+------------------------------------------------------------------+
input string USING_TIME_STOP = "";
//+------------------------------------------------------------------+
//| ,     .                   |
//+------------------------------------------------------------------+
input bool UseCloseByTime = false;
//+------------------------------------------------------------------+
//| ,       ,           |
//|      .  ,    |
//|      (UseCloseByTime = true).   |
//+------------------------------------------------------------------+
input int MaxTradeOpenHours = 48;

/*
                        
                (     !)
*/
CEnvironment Environment;              //   .
CIndicators Indicators;                //    .
CTrade Trade;                          //   .
CTradeState State;                     //    .
CTesterTable Tester;                   //    .
CDrawHedgePosition Draw;               //      (  ).
string EAName = "Ilan 1.6 Dinamic HT"; //  .
int hist_trans;                        //     .
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   DrawIndicators();
   //iRSI(Symbol(), PERIOD_CURRENT, 14, PRICE_CLOSE);
   Environment.SetMagic(MagicNumber);
   Trade.SetExpertMagicNumber(MagicNumber);
   Trade.SetDeviationInPoints(slippage);
   State.PrintSleeping(true);
   hist_trans = 0;
   //Draw.Enable(false);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
//---
   Draw.DeleteAutoTracing();
   DrawHistoryPos();
   Environment.Refresh();
   if(UseTrailingStop && !UseStopLoss && Environment.GetPositionsTotal() > 0)
      TrailingAlls(TrailStart, TrailStop, Environment.AveragePrice());
   if(UseCCIStop)
      CloseByCCI();
   if(UseEquityStop)
      CloseByEquity();
   if(!Environment.NewBarDetected())return;
   if(UseCloseByTime)
      CloseByTime();
   bool isNewPosition = false;
   bool b1 = IsLastPositionLost();
   bool b2 = Environment.GetPositionsTotal() < MaxTrades;
   if(b1 && b2)
      isNewPosition = OpenAveragingLost();
   else if(Environment.GetPositionsTotal() == 0)
      isNewPosition = OpenFirstPositionByRSI();
   if(isNewPosition)
      RecalcSLTP();
   Tester.PrintTable();
   DrawSLTP();
//---
  }

//+------------------------------------------------------------------+
//|  ,           |
//|    .            |
//| .        |
//|  'Glubina' ,    DEL.        |
//|   .    GetDynamicPips().    |
//| RESULT                                                           |
//|   ,              |
//|    .                                            |
//+------------------------------------------------------------------+
bool IsLastPositionLost(void)
{
//---
   if(Environment.LastPositionId() == 0)
   {
      if(Environment.GetPositionsTotal()>0)
         Environment.Refresh();
      if(Environment.LastPositionId() == 0)
         return false;
   }
   if(!TransactionSelect(Environment.LastPositionId(), SELECT_BY_TICKET, MODE_TRADES))
   {
      printf("Last position #" + (string)Environment.LastPositionId() + " not selected.");
      return false;
   }
   int pips = (int)MathRound(HedgePositionGetDouble(HEDGE_POSITION_PROFIT_POINTS)/ Point());
   int needPips = GetDynamicPips();
   if(pips < 0)
   {
      if(MathAbs(pips) >= GetDynamicPips())
         return true;
   }
   return false;
//---
}

//+------------------------------------------------------------------+
//|            |
//| ,   ,     |
//| .                                                         |
//| RESULT                                                           |
//|        .                 |      
//+------------------------------------------------------------------+
int GetDynamicPips(void)
{
//---
   double high = Indicators.iHighest(Symbol(), PERIOD_CURRENT, Glubina, 1);
   double low = Indicators.iLowest(Symbol(), PERIOD_CURRENT, Glubina, 1);
   double pips = MathRound((high - low)/DEL/Point());
   int PipStep = (int)pips;
   if(pips < DefaultPips/DEL)PipStep = (int)MathRound(DefaultPips/DEL);
   if(pips > DefaultPips*DEL)PipStep = (int)MathRound(DefaultPips*DEL);
   return PipStep;
//---
}
//+------------------------------------------------------------------+
//|          |
//| .                                                         |
//| RESULT                                                           |
//|   ,    ,     .  |
//+------------------------------------------------------------------+
bool OpenAveragingLost()
{
//---
   string comment = EAName + "-" + (string)(Environment.GetPositionsTotal()+1) + "-" + (string)GetDynamicPips();
   bool res_op = false;
   State.RememberDeals();
   if(Environment.CurrentDirection() == DIRECTION_LONG)
      res_op = Trade.Buy(GetLot(), Symbol(), 0.0, 0.0, 0.0, comment);
   else if(Environment.CurrentDirection() == DIRECTION_SHORT)
      res_op = Trade.Sell(GetLot(), Symbol(), 0.0, 0.0, 0.0, comment);
   else return false;
   if(!res_op)
   {
      printf("OrderSend Error: " + Trade.ResultRetcodeDescription());
      return false;
   }
   else if(!State.ChangedState())
   {
      printf("Error! State not changed.");
      return false;
   }
   if(TransactionSelect(TransactionsTotal()-1))
      Draw.DrawEntryPrice();
   return true;
//---
}
//+------------------------------------------------------------------+
//|        RSI        |
//|   .  ,          |
//|  .                                                 |
//| RESULT                                                           |
//|   ,    ,     .  |
//+------------------------------------------------------------------+
bool OpenFirstPositionByRSI()
{
//---   
   if(Environment.CurrentDirection() != DIRECTION_UNDEFINED)return false;
   double rsi = Indicators.iRSI(Symbol(), PERIOD_CURRENT, RsiPeriod, PRICE_CLOSE, 1);
   bool isUp = Indicators.iClose(Symbol(), PERIOD_CURRENT, 1) >
               Indicators.iClose(Symbol(), PERIOD_CURRENT, 2);
   bool isDown = !isUp;
   bool isBuy = rsi > RsiMinimum && isUp;
   bool isSell = rsi < RsiMaximum && isDown;
   bool res_op = false;
   string comment = EAName + "-" + (string)(Environment.GetPositionsTotal()+1) + "-" + (string)GetDynamicPips();
   State.RememberDeals();
   if(isBuy)
      res_op = Trade.Buy(Lots, Symbol(), 0.0, 0.0, 0.0, comment);
   else if(isSell)
      res_op = Trade.Sell(Lots, Symbol(), 0.0, 0.0, 0.0, comment);
   else return false;
   if(!res_op)
   {
      printf("Error: " + Trade.ResultRetcodeDescription());
      return false;
   }
   else if(!State.ChangedState())
   {
      printf("Trade state not changed.");
      return false;
   }
   if(TransactionSelect(TransactionsTotal()-1))
      Draw.DrawEntryPrice();
   return true;
//---
}
//+------------------------------------------------------------------+
//|     SL/TP                |
//|  .                                                |
//+------------------------------------------------------------------+
void RecalcSLTP()
{
//---   
   Environment.Refresh();
   if(TransactionsTotal() == 0)
      printf("Position not find");
   FOREACH_POSITION
   {
      if(!TransactionSelect(i))continue;
      if(!Environment.IsMainPosition())continue;
      IF_FROZEN continue;
      double curr_sl = HedgePositionGetDouble(HEDGE_POSITION_SL);
      double curr_tp = HedgePositionGetDouble(HEDGE_POSITION_TP);
      HedgeTradeRequest request;
      request.action = REQUEST_MODIFY_SLTP;
      bool is_modify = false;
      IF_LONG
      {
         double tp = Environment.AveragePrice() + TakeProfit * Point();
         double sl = Environment.AveragePrice() - StopLoss * Point();
         if(UseStopLoss && !Environment.DoubleEquals(curr_sl, sl) && !UseTrailingStop)
            is_modify = request.sl = sl;
         if(!Environment.DoubleEquals(curr_tp, tp))
            is_modify = request.tp = tp;
      }
      IF_SHORT
      {
         double tp = Environment.AveragePrice() - TakeProfit * Point();
         double sl = Environment.AveragePrice() + StopLoss * Point();
         if(UseStopLoss && !Environment.DoubleEquals(curr_sl, sl) && !UseTrailingStop)
            is_modify = request.sl = sl;
         if(!Environment.DoubleEquals(curr_tp, tp))
            is_modify = request.tp = tp;
      }
      if(is_modify && !SendTradeRequest(request))
      {
         printf("Failed modify SL/TP. Reason: " + Trade.ResultRetcodeDescription());
         return;
      }
   }
//---
}

//+------------------------------------------------------------------+
//|            |
//|   .                                                  |
//| INPUT PARAMETERS                                                 |
//|   needProfit -               |
//|            ,     ;      |
//|   stop -         StopLoss,      |
//|             .                             |
//|   AvgPrice -     .           |
//+------------------------------------------------------------------+
void TrailingAlls(double needProfit, double stop, double AvgPrice)
{
//---
   double profit = 0;                                       //       .
   double currStopLoss = 0.0;                               //  -.
   double stopLevel = 0.0;                                  //   -.
   double point = SymbolInfoDouble(Symbol(), SYMBOL_POINT);
   double ask = SymbolInfoDouble(Symbol(), SYMBOL_ASK);
   double bid = SymbolInfoDouble(Symbol(), SYMBOL_BID);  
   if(Environment.DoubleEquals(stop, 0.0))return;
   FOREACH_POSITION
   {
      //     .
      if(!TransactionSelect(i))continue;
      if(!Environment.IsMainPosition())continue;
      IF_FROZEN continue;
      //    .
      IF_LONG
      {
         // ,        10 (pType) .
         profit = (int)MathRound((bid - AvgPrice)/point);  
         if(profit < needProfit)continue;
         //       100(stop) .
         currStopLoss = HedgePositionGetDouble(HEDGE_POSITION_SL);
         stopLevel = bid - stop * point;
         bool stopNull = Environment.DoubleEquals(currStopLoss, 0.0);
         if(stopNull || (!stopNull && stopLevel > currStopLoss))
            ModifyStop(stopLevel);
      }
      //    .
      IF_SHORT
      {
         profit = (int)MathRound((AvgPrice - ask)/ point);
         if(profit < needProfit)continue;
         currStopLoss = HedgePositionGetDouble(HEDGE_POSITION_SL);
         stopLevel = ask + stop * point;
         bool stopNull = Environment.DoubleEquals(currStopLoss, 0.0);
         if(stopNull || (!stopNull && stopLevel > currStopLoss))
            ModifyStop(stopLevel);
      }
   }
//---
}
//+------------------------------------------------------------------+
//|   StopLoss'   .       |
//|     .                      |
//| INPUT PARAMETERS                                                 |
//|   newStopLevel -     -.           |
//+------------------------------------------------------------------+
void ModifyStop(double newStopLevel)
{
//---
   HedgeTradeRequest request;
   request.action = REQUEST_MODIFY_SLTP;
   request.sl = newStopLevel;
   request.tp = HedgePositionGetDouble(HEDGE_POSITION_TP);
   int total = TransactionsTotal();
   if(!SendTradeRequest(request))
      printf("Modify SL failed. Reason: " + (string)GetHedgeError());
//---
}

//+------------------------------------------------------------------+
//|   Drop  CCI      |
//| ,      'Drop'               |
//+------------------------------------------------------------------+ 
void CloseByCCI()
{
//---
   bool closeAll = false;
   double cci = Indicators.iCCI(Symbol(), PERIOD_CURRENT, CCIPeriod, PRICE_CLOSE, 1);
   ENUM_DIRECTION_TYPE dir = Environment.CurrentDirection();
   if(cci > CCILevel && dir == DIRECTION_SHORT)
      closeAll = true;
   else if(cci < (-CCILevel) && dir == DIRECTION_LONG)
      closeAll = true;
   if(closeAll)
   {
      printf("Closed All due to CCI");
      CloseAllPositions("Exit by CCI (" + DoubleToString(cci, 1) + ")");
   }
   
//---
}
//+------------------------------------------------------------------+
//|     .                            |
//+------------------------------------------------------------------+
void CloseAllPositions(string comment = "")
{
//---   
   int hist_total = TransactionsTotal(MODE_HISTORY);
   string s = "CLOSE ALL ";
   FOREACH_POSITION
   {
      if(!TransactionSelect(i))continue;
      if(!Environment.IsMainPosition())continue;
      IF_FROZEN continue;
      HedgeTradeRequest request;
      request.action = REQUEST_CLOSE_POSITION;
      request.exit_comment = comment;
      if(!SendTradeRequest(request))
      {
         ENUM_HEDGE_ERR err = GetHedgeError();
         printf("Failed close. Reason: " + EnumToString(err));
      }
   }
   if(TransactionsTotal(MODE_HISTORY)!= hist_total)
   {
      if(!TransactionSelect(TransactionsTotal(MODE_HISTORY), SELECT_BY_POS, MODE_HISTORY))
         return;
      Draw.DrawExitPrice();
   }
//---
}
//+------------------------------------------------------------------+
//|   ,              |
//|  MaxTradeOpenHours.                                     |
//+------------------------------------------------------------------+
void CloseByTime()
{
//---
   if(Environment.FirstPosOpen() == 0)return;
   double bars[];
   int hours = CopyClose(Symbol(), PERIOD_H1, Environment.FirstPosOpen(), TimeCurrent(), bars);
   if(hours >= MaxTradeOpenHours)
   {
      printf("Close all position by time limit.");
      CloseAllPositions("Close by Time (" + (string)hours + "h)");
   }
//---
}
//+------------------------------------------------------------------+
//|   ,     20%       |
//| (  TotalEquityRisk)      |
//|  .                                                 |
//+------------------------------------------------------------------+
void CloseByEquity()
{
//---   
   double profit = Environment.CurrentProfit();
   double hequity = Environment.GetHighEquity();
   double perDeposit = AccountInfoDouble(ACCOUNT_EQUITY)/100.0*EquityPercent;
   if(profit < 0.0 && hequity > perDeposit && MathAbs(profit) > TotalEquityRisk/100.0*hequity)
   {
      string comment = "Profit " +  (string)profit + " - " + (string)Environment.GetHighEquity();
      printf("Close all by equity stop");
      CloseAllPositions("Close by Equity stop");
   }
//---
}
//+------------------------------------------------------------------+
//|  ,     .    |
//+------------------------------------------------------------------+
double GetLot()
{
//---
   return NormalizeDouble(Lots * MathPow(LotExponent, Environment.GetPositionsTotal()+1), lotdecimal);
//---
}
//+------------------------------------------------------------------+
//|   SL/TP  .                              |
//+------------------------------------------------------------------+
void DrawSLTP()
{
   FOREACH_POSITION
   {
      if(!TransactionSelect(i))continue;
      if(!Environment.IsMainPosition())continue;
      Draw.DrawSLTP();
      // ..  TP/SL       , 
      //       .
      break;
   }
}
//+------------------------------------------------------------------+
//|      .              |
//+------------------------------------------------------------------+
void DrawHistoryPos()
{
   for(;hist_trans < TransactionsTotal(MODE_HISTORY); hist_trans++)
   {
      if(!TransactionSelect(hist_trans, SELECT_BY_POS, MODE_HISTORY))continue;
      if(!Environment.IsMainPosition())continue;
      Draw.DrawExitPrice();
      Draw.DrawHistoryLine();
   }
}

//+------------------------------------------------------------------+
//|     .                   |
//+------------------------------------------------------------------+
void DrawIndicators()
{
//---
   int handle = iRSI(Symbol(), PERIOD_CURRENT, RsiPeriod, PRICE_CLOSE);
   if(handle != INVALID_HANDLE)
   {
      int total = (int)ChartGetInteger(ChartID(), CHART_WINDOWS_TOTAL);
      if(!ChartIndicatorAdd(ChartID(), total, handle))
         printf("Failed create RSI. Reason: " + (string)GetLastError());
   }
   if(UseCCIStop)
   {
      int h_cci = iCCI(Symbol(), PERIOD_CURRENT, CCIPeriod, PRICE_CLOSE);
      int total = (int)ChartGetInteger(ChartID(), CHART_WINDOWS_TOTAL);
      if(!ChartIndicatorAdd(ChartID(), total, h_cci))
         printf("Failed create CCI. Reason: " + (string)GetLastError());
   }
   
//---
}